pipeline {
  environment {
    PROJECT_NAME="hellojs"          // project name with no any space
    IMAGE_TAG='1.0'
    TAG="localhost:5000/$PROJECT_NAME:$IMAGE_TAG"
    EXT_PORT="80"          
    INT_PORT="80"
    dockerImage = ''
  }
  agent any
  tools {nodejs "node"} 
  stages {
    stage('Cloning Git') {
      steps {
        checkout scm
      }
    }

    stage('Code Quality Check via SonarQube') {
        steps {
            script {
            def scannerHome = tool 'sonarqube';
                withSonarQubeEnv("sonarqube-container") {
                sh "${tool("sonarqube")}/bin/sonar-scanner \
                -Dsonar.projectKey=hellojs \
                -Dsonar.sources=. \
                -Dsonar.css.node=. \
                -Dsonar.host.url=http://157.245.87.70:9000 \
                -Dsonar.login=eb97f079e075052b6c1348f068281d611d6cdcf7"
                    }
                }
            }
        }

    stage('Building image') {
      steps{
        script {
          dockerImage = docker.build TAG
        }
      }
    }

    stage('Push Image') {
      steps{
        script {
            dockerImage.push()
        }
      }
    }
    
    stage('Deploy') {
      steps{
        script {
            dockerImage.run('--restart=always -p $EXT_PORT:$INT_PORT')
        }
      }
    }

  } 
}